require 'grape'
require 'date'
require 'json'

module Ignition
  class API < Grape::API  

    version 'v1', using: :path
    format :json
        
    get '/' do
      "Engine starting....#{Ignition::Daemon.manager.process_ids.keys}"
    end
    
    resource :ignition do

      get :time do
        Time.now.to_f
      end

#     send                send a bundle definiion
#     info                print bundle information
#     services            print service information
#     load                load a bundle
#     run                 run a bundle
#     stop                stop a bundle      

      get 'nodes' do
        #list the bundles available on machine
        Ignition::Daemon.manager.network_daemons
      end            

      get 'bundles' do
        #list the bundles available on machine
        Ignition::Daemon.manager.bundles
      end

      post 'bundles' do
        # post a new bundle
        begin
          puts "got a new bundle"
          pp params
          # JSON.parse(bundles_json)
          # IGMAN.add_bundles()

          data = params[:data]
          bundle = JSON.parse(data)
          #verify bundle

          Ignition::Daemon.manager.load_bundle(bundle)
        rescue Exception => exc
          error!({ "error" => "unexpected error", "detail" => exc.message }, 500)
        end

        {"status" => "OK"}
      end

      # get 'bundles/status' do

      # end

      # get 'bundle/:name/status' do

      # end

      # get 'bundle/:name/run' do

      # end

      # get 'bundle/:name/stop' do

      # end

      delete 'bundle/:name' do
        # data = params[:data]

        begin
          Ignition::Daemon.manager.unload_bundle({"id" => params[:name]})
        rescue Exception => exc
          error!({ "error" => "unexpected error", "detail" => exc.message }, 500)
        end

        {"status" => "OK"}
      end

      get 'bundle/:name/scale/:count' do
        puts params[:name]
        puts params[:count]
        begin
          Ignition::Daemon.manager.scale(params[:name], params[:count].to_i)
        rescue Exception => exc
          error!({ "error" => "unexpected error", "detail" => exc.message }, 500)
        end
        pp params
        {"status" => "OK"}
      end 

      get 'bundle/:name/logs' do
        puts params[:name]
        pp Ignition::Daemon.manager.recent_logs
        logs = Ignition::Daemon.manager.logs(params[:name])
        pp logs
        logs
      end 

    end
  end
end