require 'rack'
# require 'ignition_api'

require 'ignition/load_common'

require "ignition/engine/broadcast_client"
require "ignition/engine/broadcast_message"
require "ignition/engine/manager"

require "ignition/api"

class Ignition::Daemon

  class << self

  	def run
		server = ::Rack::Handler::WEBrick

		hostname = Socket.gethostname

		ignition_address = "0.0.0.0"
		unless ENV["IGNITION_ADDRESS"].blank?
			ignition_address = ENV["IGNITION_ADDRESS"]
		end

		ignition_port = 6753
		unless ENV["IGNITION_PORT"].blank?
			ignition_port = ENV["IGNITION_PORT"].to_i
		end

		broadcast_client = BroadcastClient.new(hostname,ignition_address,ignition_port)

		@manager = Ignition::Manager.new(broadcast_client)

		proc = Proc.new { 
			server.shutdown 
			broadcast_client.stop!
		}

		@manager.run( proc )

		server.run Ignition::API , :Host => ignition_address, :Port => ignition_port
	end

	def manager
		@manager
	end

end
end