class Ignition::BundleStatus < Hash
	def initialize(h={})
		update(h)
		self.pids = []	if self['pids'].nil?
		self.scale = 0	if self['scale'].nil?

		pp self
	end

	def add_pid(pid)
		pids << pid
		update_bundle_running_status
	end

	def remove_pid(pid)
		pids.delete(pid)
		update_bundle_running_status
	end

	def clean_pids
		deleted = 0
		pids.each do |pid|
			if !is_process_running(pid)
				pids.delete(pid)
				deleted += 1
			end
		end
		update_bundle_running_status
		deleted
	end	

	def is_process_running(pid)
		begin
		  Process.getpgid( pid )
		  true
		rescue Errno::ESRCH
		  false
		end
	end

	def update_bundle_running_status
    	if (self.pids.size == 0)
    		self.message = "STOPPED"
    	else
    		self.message = "RUNNING"
		end
	end

end